//
// Classe per rappresentare una Coda. Prima versione che utilizza un array.
//

typedef int mytype;			// Il tipo dei nostri dati

class Queue {
  int head;		// Indice della testa
  int len;		// Lunghezza attuale della Coda
  int maxlen;		// Dimensione della Coda
  mytype *data;		// Puntatore agli elementi della Coda

public:
  Queue(int size = 1024);	 // Costruttore
  ~Queue();			 // Distruttore

  mytype Read();		 // Restituisce l'elemento in testa alla Coda
  void Enqueue(const mytype &d); // Aggiunge un elemento in fondo alla Coda
  mytype Dequeue();		 //Rimuove l'elemento in testa alla Coda (e lo
				 // restituisce)
  int IsEmpty()			 // La Coda e` vuota?
    { return(len == 0); }
};
